/* 
	listTargets - usermode RE of Torpig/MBR 
	Michael Hale Ligh m(2008)

	Run this program on a system infected with Torpig/MBR
	to print the list of targets. 

	c:\> listTargets > output.txt
*/

#include <windows.h>
#include <tchar.h>
#include <stdio.h>

#define DOMAIN_TARGETS_A 0x17
#define DOMAIN_TARGETS_B 0x18
#define DOMAIN_TARGETS_C 0x19
#define DOMAIN_TARGETS_D 0x1a

typedef struct pipeCONTROL {
	BYTE	helloStatus;
	BYTE	Reserved0[3];
	BYTE	reqType;
	BYTE	Reserved1;
} PIPE_CONTROL;

static BYTE i;

VOID WriteKernelPipe(HANDLE hPipe, LPBYTE lpData, DWORD ddSize)
{
	DWORD ddWritten;

	if (!WriteFile(
		hPipe, 
		lpData,
		ddSize,
		&ddWritten,
		NULL) || ddWritten != ddSize)
	{
		_tprintf(TEXT("Cannot write to pipe: %d\n"), GetLastError());
		CloseHandle(hPipe);
		ExitProcess(0);
	}
}

VOID ReadKernelPipe(HANDLE hPipe, LPBYTE lpData, DWORD ddSize)
{
	DWORD ddRead;

	if (!ReadFile(
		hPipe, 
		lpData, 
		ddSize, 
		&ddRead, 
		NULL) || ddRead != ddSize)
	{
		_tprintf(TEXT("Cannot read from pipe: %d\n"), GetLastError());
		CloseHandle(hPipe);
		ExitProcess(0);
	}
}

VOID SearchAndReplace(LPSTR lpStr)
{
	LPSTR lpStart	= lpStr;
	LPSTR sp		= NULL;
	while((sp = strchr(lpStart, ' ')) != NULL)
	{ 
		*sp   = 0x0a; 
		lpStart = sp; 
	}
	return;
}

VOID PrintCharacters(LPSTR lpStr, DWORD ddSize)
{
	DWORD	i;
	CHAR	c;

	for(i=0; i<ddSize; i++) {
		c = lpStr[i];
		if (c == '\r' || c == '\n' || \
			(c >= 0x20 && c <= 0x7f))
			printf("%c", c);
	}
}

VOID ExecPipeRequest(BYTE requestType)
{
	DWORD			ddSize;
	LPBYTE			lpData;
	HANDLE			hHeap = GetProcessHeap();
	PIPE_CONTROL	pipeCtrl;

	// Open the rootkit kernel pipe
	HANDLE hPipe = CreateFile(
		TEXT("\\\\.\\pipe\\!win$"), 
		GENERIC_READ | GENERIC_WRITE, 
		0,
		NULL, 
		OPEN_EXISTING,
		0,
		NULL);

	if (hPipe == INVALID_HANDLE_VALUE) {
		_tprintf(TEXT("Cannot connect named pipe: %d\n"), GetLastError());
		ExitProcess(0);
	}

	DWORD lpMode = PIPE_READMODE_MESSAGE;

	if (!SetNamedPipeHandleState(
		hPipe, 
		&lpMode, 
		NULL, NULL))
	{
		_tprintf(TEXT("Cannot set handle state: %d\n"), GetLastError());
		CloseHandle(hPipe);
		ExitProcess(0);
	}

	pipeCtrl.helloStatus = 1;
	WriteKernelPipe(hPipe, (LPBYTE)&pipeCtrl, sizeof(BYTE));

	pipeCtrl.helloStatus = 2;
	WriteKernelPipe(hPipe, (LPBYTE)&pipeCtrl, sizeof(BYTE));
	
	// Send the request size
	ddSize = sizeof(pipeCtrl);
	WriteKernelPipe(hPipe, (LPBYTE)&ddSize, sizeof(DWORD));

	// Send the request type
	ZeroMemory(&pipeCtrl, sizeof(pipeCtrl));
	pipeCtrl.reqType = requestType;
	WriteKernelPipe(hPipe, (LPBYTE)&pipeCtrl, sizeof(pipeCtrl));

	FlushFileBuffers(hPipe);

	// Read the response type
	ReadKernelPipe(hPipe, (LPBYTE)&pipeCtrl, sizeof(BYTE));
	if (pipeCtrl.helloStatus != ERROR_SUCCESS) {
		_tprintf(TEXT("Got invalid response type: %d\n"), pipeCtrl.helloStatus);
		CloseHandle(hPipe);
		ExitProcess(0);
	}

	// Read the response size
	ReadKernelPipe(hPipe, (LPBYTE)&ddSize, sizeof(DWORD));
	if (!ddSize) {
		_tprintf(TEXT("Got invalid response size: %d\n"), ddSize);
		CloseHandle(hPipe);
		ExitProcess(0);
	}

	lpData = (LPBYTE) HeapAlloc(hHeap, HEAP_ZERO_MEMORY, ddSize+1);
	if (lpData == NULL) {
		_tprintf(TEXT("Cannot allocate %d bytes: %d\n"), ddSize, GetLastError());
		CloseHandle(hPipe);
		ExitProcess(0);
	}

	ReadKernelPipe(hPipe, lpData, ddSize);
	LPSTR lpStart = (LPSTR) lpData + 8;

	if (strlen(lpStart) > 10)
		printf("\n\n==== [id:0x%2.2x] ============================================\n\n", i);

	if (requestType == DOMAIN_TARGETS_A || \
		requestType == DOMAIN_TARGETS_B || \
		requestType == DOMAIN_TARGETS_C || \
		requestType == DOMAIN_TARGETS_D) 
	{
		SearchAndReplace(lpStart);
		printf("%s", lpStart);
	} else {
		PrintCharacters(lpStart, ddSize-8);
	}

	CloseHandle(hPipe);
	HeapFree(hHeap, 0, lpData);
	return;
}

#define MAX_REQUEST_TYPE 0x23

int main (int argc, char * argv[]) 
{
	if (argc == 2) {
		int z = atoi(argv[1]);
		ExecPipeRequest(z);
	} else {
		for (i=0; i<MAX_REQUEST_TYPE; i++) ExecPipeRequest(i);
	}

	return 0;
}