"""

KrakenHostnames - C&C Hostname Generation
Michael Hale Ligh and Greg Sinclair @ iDefense
http://code.google.com/mhl-malware-scripts

"""

import immlib

def main ():
    imm = immlib.Debugger()
    table = imm.createTable('Kraken Hosts', ['Index', 'Host'])
    start = 0x0085E604 # Start of hostname generation function
    imm.setBreakpoint(start)
    imm.setBreakpoint(0x0085E76A) # End of the function
    imm.setBreakpoint(0x0085E60A) # After prologue of function
    memvar = imm.remoteVirtualAlloc(4)
    remember = ""

	# Iterate the algorithm, modifying the function parameters
    for idx in range(0,2000):
        imm.setReg("EIP", start)
        imm.Run()
        imm.Run()
        regs = imm.getRegs()
        imm.writeLong(regs['EBP']+8, memvar)
        imm.writeLong(regs['EBP']+12, idx)
        imm.Run()
        host = imm.readString(imm.readLong(memvar))
        # Quit when there are no more
        if len(host) <= 0:
            break
        # Don't print consecutive dups
        if remember != host:
            table.add('', ['%x' % idx, '%s' % host])
        remember = host